type id = string

datatype exp =                 (* a ::= *)
    VarExp of id                  (* x *)
  | AppExp of exp * exp           (* a1 a2 *)
  | FnExp of id * exp             (* fn x => a *)
  | ValExp of id * exp * exp      (* val x = a1 in a2 *)
